<template>
    <div class="settings_block">
        <div class="settings_block__content flex-wrap">
            <div class="col-12 settings_block__item my_domain">
                <Title
                    v-model="active"
                    @input="active && checkVerify(), loadingVerify = true"
                />
                <template v-if="active">
                    <div
                        v-if="loadingVerify"
                        style="height: 40px; margin-top: 40px;"
                    >
                        <div :class="{'loading-sm loading-sm_blue': loadingVerify}" />
                    </div>
                    <EnterDomain 
                        v-show="!loadingVerify"
                        ref="enter_domain"
                        v-model="domain"
                        class="my_domain__enter_domain" 
                        :domain="domain" 
                        :step="steps[step]"
                        :verify="isVerifyDomain" 
                        :loading="loading.cnames"
                        @next="$emit('startLoad', 'cnames'), getCnameItems($event)"
                        @clearSteps="clearSteps"
                    /> 

                    <TableCname 
                        v-if="!isVerifyDomain.title && steps[step] == 'table_cname' && tableCnameItems"
                        :loading="loading.verify"
                        :domain="domain"
                        :items="tableCnameItems"
                        :validation-result="isVerifyDomain.validation_results"
                        @next="$emit('startLoad', 'verify'), verifyDomain(domain), clearAlerts()"    
                    />

                    <FullEmail 
                        v-if="isVerifyDomain.title || steps[step] == 'full_email'" 
                        :loading="loading.save" 
                        :from-email="fromEmail"
                        @next="$emit('startLoad', 'save'), $emit('updFromEmail', $event)"
                    />
                </template>
            </div>
        </div>
    </div>
</template>

<script>
import Title from './notify/Title.vue'
import EnterDomain from './notify/EnterDomain.vue'
import TableCname from './notify/TableCname.vue'
import FullEmail from './notify/FullEmail.vue'
import {settings} from '@/mixins/settings'
export default {
  components: {
    Title,
    EnterDomain,
    TableCname,
    FullEmail,
  },
  mixins: [settings],
  props: ["loading", "fromEmail"],
  data() {
    return {
      active: false,
      domain: null,
      loadingVerify: false,
      steps: ["enter_domain", "table_cname", "full_email"],
      step: 0,
      tableCnameItems: null,
      verifyCnameItems: [],
      showSafeSend: false,
      isVerifyDomain: {validation_results: [], title: false, alert: {success: false, error: false}},
    };
  },
  created() {
    this.checkCustomDomain()
  },
  methods: {
    checkCustomDomain() {
      if(this.$store.state.shop.shop.custom_domain) {
        this.active = true
        this.loadingVerify = true
        this.checkVerify()
      }
    },
    clearAlerts() {
      if(this.isVerifyDomain.alert.success) this.isVerifyDomain.alert.success = false
      if(this.isVerifyDomain.alert.error) this.isVerifyDomain.alert.error = false
      if(this.isVerifyDomain.title)  this.isVerifyDomain.title = false
    },
    clearSteps() {
      this.clearAlerts()
      this.$emit('clearLoads')
      this.$emit('clearFromEmail')
      this.step = 0
    }
  }
};
</script>


<style lang="scss" scoped>
@import "../../../../../css/settings/index.scss";
@media(min-width: 1200px) {
  .my_domain {
    padding-right: 37px;
    padding-left: 37px;
  }
}

.settings_block__item {
  margin-bottom: 0;
}


::v-deep .notif {
  margin-top: 5px;
}
// @media(min-width: 768px) {
//   .settings_block__content {
//     padding-left: 34px;
//     padding-right: 34px;
//   }
// }
</style>